{ $apptype console}
{$A-,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T+,V+,X+}
const
  maxCount = 256;  {max--  ६  method'   256}
  _keyword = 0;
  _ident   = 1;
type
  { ⠡ }
  tNameTable = record
    name : string[10];   { ६}
    typ  :  byte;        {_ident, _keyword}
    case byte of
      _ident:   (adr:  word);  {  ᥣ }
      _keyword: (tok:  byte);  { keyword}
  end;
var
  nameTable : array[0..maxCount] of tNameTable;
  tnCount   : integer;
var
  mem : array[0..$7FFF] of byte;
  IP, DP, SP: word;   {㯯 PI}
  IR: byte;           {믮塞 }
  running: boolean;   {ணࠬ 믮  running}

{----------- 㫧  ࠡ⪠ 訡 ---------------}
function hex(b : byte) : string;
const
  h : array[0..$0F] of char = '0123456789ABCDEF';
begin
  hex := h[b shr 4]+h[b and $0F];
end;

function hex2(w : word) : string;
begin
  hex2 := hex(hi(w))+hex(lo(w));
end;

procedure error(msg : string);
begin
  writeLn('Error: ',msg);
  halt;
end;

{------- 楤  ࠡ  ⠡楩  --------}
function addObject(name : string;  typ : byte;  adr : word) : word;
{   ⠡ }
begin
  inc(tnCount);
  if tnCount>maxCount then error('nameTable OFF');
  nameTable[tnCount].name:=name;
  nameTable[tnCount].typ:=typ;
  case typ of
    _ident:   begin
                nameTable[tnCount].adr:=DP;
                inc(DP, 2);
              end;
    _keyword: nameTable[tnCount].tok:=byte(adr);
  end;
  addObject:=tnCount;
end;

function find(name : string) : integer;
{  ⠡ 䨪   name, ᫨ = 0,   }
var
  i : integer;
begin
  i:=tnCount;
  nameTable[0].name:=name;  {⠭  0 ,..  㤥 ᮢ}
  while nameTable[i].name<>name do  dec(i);
  find:=i;
end;

function lockKey(name : string) : byte;
{ ⨯  ⠡ }
var
  i : integer;
begin
  lockKey:=_ident;
  i:=find(name);
  if i<>0 then
    if nameTable[i].typ=_keyword then
      lockKey:=nameTable[i].tok;
end;

function lockVar(name : string) : word;
{  ६}
var
  i : integer;
begin
  i:=find(name);
  if i=0 then lockVar:=addObject(name, _ident, 0) { ६}
    else lockVar:=i;  { 稬  }
end;

{--- ணࠬ  ᮪饭 java-設 --}
const
  {設 }
  _iconst_0=$01;
  _iconst_1=$02;
  _iconst_2=$03;
  _iconst_3=$04;
  _push    =$05;
  _load    =$06;
  _store   =$07;
  {_swap   =$08;{}
  _iadd    =$09;
  _isub    =$10;
  _cmp     =$11;
  _imul    =$12;
  _idiv    =$13;
  _goto    =$14;
  _ifeq    =$15; {室, ᫨ ࠢ 0}
  _ifne    =$16; {室, ᫨  ࠢ 0}
  _iflt    =$17; {室, ᫨  0}
  _ifge    =$18; {室, ᫨   ࠢ 0}
  _ifgt    =$19; {室, ᫨  0}
  _ifle    =$20; {室, ᫨   ࠢ 0}
  _iwrt    =$21;
  _cwrt    =$22;
  _wrtLn   =$23;
  _iread   =$24;
  _readLn  =$25;
  _hlt     =$FF;

function fetchAdr : word;
begin
  fetchAdr := mem[IP]*$100+mem[IP+1];
  inc(IP,2);
end;

procedure push(i:integer);
begin
  dec(SP,2);
  mem[SP+1]:=hi(i);
  mem[SP]:=lo(i);
end;

function pop : integer;
begin
  pop:=mem[SP]+mem[SP+1]*$100;
  inc(SP,2);
end;

procedure execute;
var
  i1,i2 : integer;
begin
  case IR of
    _iconst_0: push(0);
    _iconst_1: push(1);
    _iconst_2: push(2);
    _iconst_3: push(3);
    _push:     push(fetchAdr);
    _load:     begin i1:=DP+nameTable[mem[ip]].adr; inc(ip); push(mem[i1]*$100+mem[i1+1]); end;
    _store:    begin i1:=DP+nameTable[mem[ip]].adr; inc(ip); i2:=pop; mem[i1]:=hi(i2); mem[i1+1]:=lo(i2); end;
    {_swap:     begin i1:=pop; i2:=pop; push(i1); push(i2); end;{}
    _iadd:     push(pop+pop);
    _isub,_cmp:push(pop-pop);
    _imul:     push(pop*pop);
    _idiv:     push(pop div pop);
    _goto:     inc(IP,fetchAdr-3);
    _ifeq:     if (pop=0)  then inc(IP,fetchAdr-3) else inc(IP,2); {室,᫨ =  0}
    _ifne:     if (pop<>0) then inc(IP,fetchAdr-3) else inc(IP,2); {室,᫨ <> 0}
    _iflt:     if (pop<0)  then inc(IP,fetchAdr-3) else inc(IP,2); {室,᫨ <  0}
    _ifge:     if (pop>=0) then inc(IP,fetchAdr-3) else inc(IP,2); {室,᫨ >= 0}
    _ifgt:     if (pop>0)  then inc(IP,fetchAdr-3) else inc(IP,2); {室,᫨ >  0}
    _ifle:     if (pop<=0) then inc(IP,fetchAdr-3) else inc(IP,2); {室,᫨ <= 0}
    _iwrt:     begin write(pop, ' '); inc(ip,2); end;
    _cwrt:     begin write(chr(pop)); inc(ip,2); end;
    _wrtLn:    begin writeln; inc(ip,2); end;
    _iread:    begin
                 repeat
                   write('input:');
                   {$I-}read(i1);{$I+}
                   i2:=IOresult;
                   if i2<>0 then writeln('error: input number [-32768..32767]');
                 until i2=0;
                 push(i1);
                 inc(ip,2);
               end;
    _readLn:   begin readln; inc(ip,2); end;
    _hlt:      running:=false;
  end;
end;

procedure run;
begin
  writeln;
  writeln('run code:');
  IP:=0;
  running:=true;
  repeat
    IR:=mem[IP]; {롮ઠ । }
    inc(IP);
    {  ⠢ ᮯ}
    execute;    {믮 }
    { ॠ  뢠}
  until running=false;
  writeln('-----');
end;

procedure listCmd;
var
  i,adr : integer;
begin
  case IR of
    _iconst_0: write('iconst_0');
    _iconst_1: write('iconst_1');
    _iconst_2: write('iconst_2');
    _iconst_3: write('iconst_3');
    _push:     write('sipush           $',hex2(word(fetchAdr)));
    _load:     begin
                 i:=mem[ip]; inc(ip);
                 write('iload            ',i-10,'  {',nameTable[i].name,'=addr[',hex2(word(nameTable[i].adr)),']}');
               end;
    _store:    begin
                 i:=mem[ip]; inc(ip);
                 write('istore           ',i-10,'  {',nameTable[i].name,'=addr[',hex2(word(nameTable[i].adr)),']}');
               end;
    {_swap:     write('swap');{}
    _iadd:     write('iadd');
    _isub,_cmp:write('isub');
    _imul:     write('imul');
    _idiv:     write('idiv');
    _goto:     write('goto             $',hex2(word({ip-3+{}fetchAdr)));
    _ifeq:     write('ifeq             $',hex2(word({ip-3+{}fetchAdr)));
    _ifne:     write('ifne             $',hex2(word({ip-3+{}fetchAdr)));
    _iflt:     write('iflt             $',hex2(word({ip-3+{}fetchAdr)));
    _ifge:     write('ifge             $',hex2(word({ip-3+{}fetchAdr)));
    _ifgt:     write('ifgt             $',hex2(word({ip-3+{}fetchAdr)));
    _ifle:     write('ifle             $',hex2(word({ip-3+{}fetchAdr)));
    _iwrt:     begin write('invokestatic     prog.iwrite "(I)V"'); inc(ip,2); end;
    _cwrt:     begin write('invokestatic     prog.cwrite "(I)V"'); inc(ip,2); end;
    _wrtLn:    begin write('invokestatic     prog.writeln "()V"'); inc(ip,2); end;
    _iread:    begin write('invokestatic     prog.read "()I"'); inc(ip,2); end;
    _readLn:   begin write('invokestatic     prog.readln "()V"'); inc(ip,2); end;
    _hlt:      begin write('return'); running:=false; end;
    else       write('err:'+hex(ir)+'h');
  end;
end;

procedure list;
var
  i : integer;
begin
  writeln('{CODE-LIST: jc.class. by arT (c).  e-mail: IronWoodcutter@bk.ru}');
  writeln('class jc "jc"');
  writeln('class Object "java/lang/Object"');
  writeln('class Runnable "java/lang/Runnable"');
  writeln('class prog "prog"');
  writeln('interface Runnable');
  writeln('method "PUBLIC" <init> "()V"');
  writeln('localvariabletable this "Ljc;"');
  writeln('{0000}  aload_0');
  writeln('{0001}  invokenonvirtual Object.<init> "()V"');
  writeln('{0004}  return');
  writeln('endmethod');
  writeln('method "PUBLIC" run "()V"');
  {writeln('localvariabletable this "Ljc;"');
  writeln('stackmap integer 0 -v');
  writeln('invokestatic     prog.read "()I"');
  writeln('pop');
  writeln('goto             $FFFC');{}
  for i:=1 to tnCount do
    if nameTable[i].typ=_ident then
      writeln('localvariabletable '+nameTable[i].name+' "I"');
  IP:=0;
  running:=true;
  repeat
    write('{'+hex2(IP)+'}  ');
    IR:=mem[IP];
    inc(IP);
    listCmd;
    writeln;
  until running=false;
  writeln('endmethod');
end;


{------------- ᪨  ---------------}
const
  {⨯ ᥬ}
  _lparent = 2;
  _rparent = 3;
  _integer = 4;
  _unknow  = 10;
  _plus    = 11;
  _minus   = 12;
  _mul     = 13;
  _div     = 14;
  _comma   = 15;
  _eql     = 21; {=}
  _neg     = 22; {<>}
  _lss     = 23; {<}
  _lea     = 24; {<=}
  _begin   = 31;
  _if      = 32;
  _then    = 33;
  _else    = 34;
  _while   = 35;
  _end     = 36;
  _write   = 37;
  _read    = 38;
  _kvk     = 39;
  _ch      = 40;
  _do      = 41;
var
  ch: char;        {⠭ 室 ᨬ}
  tTok: byte;      {⨯ ᥬ}
  sTok: string;    {ப ।⠢ ᥬ}
  iTok: integer;   {᫨ ᥬ ᫮ -  ᫮ 祭}

procedure nextch;
begin
  read(ch);
end;

procedure get;
begin
  sTok:='';
  while (ch<=#32) do nextch;
  case upcase(ch) of
    'A'..'Z':begin
               while upcase(ch) in ['A'..'Z', '0'..'9', '_'] do
               begin
                 sTok:=sTok+upcase(ch);
                 nextch;
               end;
               tTok:=lockKey(sTok);
             end;
    '0'..'9':begin
               iTok := 0;
               while ch in ['0'..'9'] do
               begin
                 {sTok:=sTok+ch;{}
                 iTok:=iTok*10+ord(ch)-ord('0');
                 nextch;
               end;
               tTok:=_integer;
             end;
    '''': begin tTok:=_kvk; nextch; end;
    '#' : begin tTok:=_ch; nextch; end;
    ',' : begin tTok:=_comma; nextch; end;
    '+' : begin tTok:=_plus; nextch; end;
    '-' : begin tTok:=_minus; nextch; end;
    '*' : begin tTok:=_mul; nextch; end;
    '/' : begin tTok:=_div; nextch; end;
    '(' : begin tTok:=_lparent; nextch; end;
    ')' : begin tTok:=_rparent; nextch; end;
    '=' : begin tTok:=_eql; nextch; end;
    '<' : begin   { <, <=, <> }
           nextch;
           if ch= '=' then
           begin
             tTok:=_lea;
             nextch;
           end
           else if ch= '>' then
           begin
             tTok:=_neg;
             nextch;
           end else tTok:=_lss;
         end;
    #26: error('Unexpected EOF');
    else tTok:=_unknow;
  end;
end;

{-------------    設 --------------}
procedure emit(cmd : integer);
begin
  mem[IP]:=cmd;
  inc(IP);
end;

procedure emit1(cmd, val : byte);
begin
  emit(cmd);
  emit(val);
end;

procedure emit2(cmd, val : integer);
begin
  emit(cmd);
  emit(hi(val));
  emit(lo(val));
end;

procedure fixUp(adr, val : integer);
{ - ࠢ ࠭   ⨯ jmp}
begin
  mem[adr+1]:=hi(val);
  mem[adr+2]:=lo(val);
end;

{- ᨭ⠪᪨ , ⮡   -}
procedure _boolExpression; forward;

procedure factor;
begin
  case tTok of
    _ident:   emit1(_load, lockVar(sTok));
    _integer: case iTok of  {load const}
               0:  emit(_iconst_0);
               1:  emit(_iconst_1);
               2:  emit(_iconst_2);
               3:  emit(_iconst_3);
               else emit2(_push, iTok);
              end;
    _lparent: begin
                get;
                _boolExpression;
                if tTok<>_rparent then error('not found ")"');
              end;
    else error('ErrInExpr');
  end;
  get;
end;

procedure term;
var
  op: byte;
begin
  factor;
  while tTok in [_mul, _div] do
  begin
    op:=tTok;
    get;
    factor;
    case op of
      _mul: emit(_imul);
      _div: emit(_idiv);
    end;
  end;
end;

procedure expression;
var
  op: byte;
begin
  if tTok in [_plus, _minus] then emit(_iconst_0)
    else term;
  while tTok in [_plus, _minus] do
  begin
    op:=tTok;
    get;
    term;
    case op of
      _plus:  emit(_iadd);
      _minus: emit(_isub);
    end;
  end;
end;

procedure _boolExpression;
var
  op: byte;
begin
  expression;
  if tTok in [_eql, _neg, _lss, _lea] then
  begin
    op:=tTok;
    get;
    expression;
    emit(_cmp);     {ࠢ  祩  誥 ⥪  ⠭ 0  1}
    case op of
      _eql: emit2(_ifeq,7);
      _neg: emit2(_ifne,7);
      _lss: emit2(_iflt,7);
      _lea: emit2(_ifle,7);
    end;
    emit(_iconst_0);
    emit2(_goto,4);
    emit(_iconst_1);
  end;
end;

procedure statement; forward;

procedure input;
{ - ॠ ⥩襣 ਠ readln}
begin
  repeat
    get;
    {  ६  ᥣ   ᫨  ⠬  - }
    emit2(_iread,0);
    emit1(_store, lockVar(sTok)); { १}
    get;
  until tTok<>_comma;
  emit2(_readLn,0);
end;

procedure print;
{ - ॠ ⥩襣 ਠ writeln}
begin
  repeat
    get;
    case tTok of
      _kvk: begin {뢮 ⠭⭮ ப(ࠡ ⮫쪮  ⮬ )}
              while ch<>'''' do
              begin
                emit2(_push, ord(ch));  {load const-char}
                emit2(_cwrt,0);         {뢮 ᨬ  ॣ AX}
                nextch;
              end;
              nextch;
              get;
            end;
      _ch:  begin {뢮 ᨬ  ࠦ}
              get;
              _boolExpression;
              emit2(_cwrt,0);
            end;
      else  begin {뢮 ᫮ ࠦ}
              _boolExpression;
              emit2(_iwrt,0);
            end;
    end;
  until tTok<>_comma;
  emit2(_wrtLn,0);
end;

procedure assignment;
{ -  ᢠ (⨯ a:=...)}
var
  adr : word;
begin
  {  ६  ᥣ   ᫨  ⠬  - }
  adr := lockVar(sTok);
  get;
  if tTok<>_eql then error('not found ":="');
  get;
  _boolExpression;
  emit1(_store, adr); { १}
end;

procedure whileState;
var
  pc1,pc2 : integer;
begin
  get;
  pc1:=IP;            { 砫 while}
  _boolExpression;     {᫨ ࠦ}
  pc2:=IP;            {  }
  emit2(_ifeq, 0);    {᫨=0   while,  筨 ⮬}
  if tTok<>_do then error('not found "do"');
  get;
  statement;
  emit2(_goto,pc1-ip);    {  砫 while}
  fixUp(pc2, ip-pc2);     {⠢塞 }
end;

procedure ifState;
var
  pc1,pc2 : integer;
begin
  get;
  _boolExpression;     {᫨ ࠦ}
  pc1:=IP;            {  JMP - ⮡ ⮬ ࠢ }
  emit2(_ifeq, 0);    {  THEN ᫨ ᫮  믮}
  if tTok<>_then then error('not found "then"');
  get;
  statement;          { THEN}
  if tTok=_else then
  begin
    get;
    pc2:=IP;          {    THEN}
    emit2(_goto, 0);  {⠢  JMP  樨 IF_THEN_ELSE}
    fixUp(pc1, IP-pc1);
    statement;        { ELSE}
    fixUp(pc2, IP-pc2);  {⠢塞 }
  end
    else fixUp(pc1, IP-pc1);  {ࠢ塞  -  ELSE }
end;

procedure beginState;
{ - ࠡ⪠ begin ... end}
begin
  get;
  while tTok<>_end do statement;
end;

procedure statement;
begin
  case tTok of
    _begin: beginState;
    _while: whileState;
    _if:    ifState;
    _write: print;
    _read:  input;
    _ident: assignment;
    else error('don''t know statement: '+sTok);
  end;
end;

procedure init;
begin
  {init get}
  nextch;

  {init Mashin}
  IP:=0;
  DP:=0;
  SP:=$7FFF;  {⥪    ( ᢥ-)}

  {樠 ⠡ }
  tnCount:=0;
  addObject('BEGIN', _keyword, _begin);
  addObject('ELSE',  _keyword, _else);
  addObject('END',   _keyword, _end);
  addObject('IF',    _keyword, _if);
  addObject('THEN',  _keyword, _then);
  addObject('WHILE', _keyword, _while);
  addObject('DO',    _keyword, _do);
  addObject('WRITE', _keyword, _write);
  addObject('READ',  _keyword, _read);
end;

procedure compile;
begin
  get;          {   计 ࠧ ஫ ணࠬ}
  statement;
  emit(_hlt);   {, ᭮, }
end;

begin
  init;
  compile;
  DP:=IP;   {ᥣ  ᫥  ணࠬ}
  list;
  if (paramStr(1)<>'list') then run;{}
end.
